---
title: Batch update LLM Observability dataset records
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Batch update LLM Observability dataset records{% #batch-update-llm-observability-dataset-records %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                                         |
| ----------------- | ---------------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/llm-obs/v1/{project_id}/datasets/{dataset_id}/batch_update |

### Overview

Insert, update, and delete records in a single dataset operation. By default, a new dataset version is created when the batch is applied.

### Arguments

#### Path Parameters

| Name                         | Type   | Description                              |
| ---------------------------- | ------ | ---------------------------------------- |
| project_id [*required*] | string | The ID of the LLM Observability project. |
| dataset_id [*required*] | string | The ID of the LLM Observability dataset. |

### Request

#### Body Data (required)

Batch update payload.

{% tab title="Model" %}

| Parent field    | Field                        | Type                | Description                                                                                                                                                                                        |
| --------------- | ---------------------------- | ------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                 | data [*required*]       | object              | Data object for batch-updating records in an LLM Observability dataset.                                                                                                                            |
| data            | attributes [*required*] | object              | Attributes for batch-updating records in an LLM Observability dataset.                                                                                                                             |
| attributes      | create_new_version           | boolean             | Whether to create a new dataset version when applying the batch update. Defaults to `true`.                                                                                                        |
| attributes      | delete_records               | [string]            | Record IDs to delete.                                                                                                                                                                              |
| attributes      | insert_records               | [object]            | Records to insert.                                                                                                                                                                                 |
| insert_records  | expected_output              | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| expected_output | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| expected_output | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| expected_output | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| expected_output | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| expected_output | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| insert_records  | id                           | string              | Optional user-provided identifier for the record. If omitted, the server generates an identifier.                                                                                                  |
| insert_records  | input [*required*]      | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| input           | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| input           | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| input           | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| input           | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| input           | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| insert_records  | metadata                     | object              | Arbitrary metadata associated with the record.                                                                                                                                                     |
| insert_records  | tag_operations               | object              | Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. `set` is the final override; if specified, the result of `remove` and `add` is discarded. |
| tag_operations  | add                          | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | remove                       | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | set                          | [string]            | List of tag strings.                                                                                                                                                                               |
| insert_records  | tags                         | [string]            | List of tag strings.                                                                                                                                                                               |
| attributes      | tags                         | [string]            | List of tag strings.                                                                                                                                                                               |
| attributes      | update_records               | [object]            | Records to update by ID.                                                                                                                                                                           |
| update_records  | expected_output              | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| expected_output | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| expected_output | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| expected_output | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| expected_output | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| expected_output | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| update_records  | id [*required*]         | string              | Unique identifier of the record to update.                                                                                                                                                         |
| update_records  | input                        | object <oneOf> | Represents any valid JSON value.                                                                                                                                                                   |
| input           | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| input           | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| input           | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| input           | Option 4                     | [ <oneOf>]     | An array of arbitrary values.                                                                                                                                                                      |
| Option 4        | Option 1                     | string              | A scalar string value.                                                                                                                                                                             |
| Option 4        | Option 2                     | double              | A scalar numeric value.                                                                                                                                                                            |
| Option 4        | Option 3                     | object              | An arbitrary object value with additional properties.                                                                                                                                              |
| Option 4        | Option 4                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| input           | Option 5                     | boolean             | A scalar boolean value.                                                                                                                                                                            |
| update_records  | metadata                     | object              | Updated metadata associated with the record.                                                                                                                                                       |
| update_records  | tag_operations               | object              | Explicit tag operations for updating records. Operations are applied in order, Remove then Add then Set. `set` is the final override; if specified, the result of `remove` and `add` is discarded. |
| tag_operations  | add                          | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | remove                       | [string]            | List of tag strings.                                                                                                                                                                               |
| tag_operations  | set                          | [string]            | List of tag strings.                                                                                                                                                                               |
| data            | id [*required*]         | string              | Unique identifier of the dataset.                                                                                                                                                                  |
| data            | type [*required*]       | enum                | Resource type of an LLM Observability dataset. Allowed enum values: `datasets`                                                                                                                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "create_new_version": true,
      "delete_records": [],
      "insert_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          },
          "tags": []
        }
      ],
      "tags": [],
      "update_records": [
        {
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "tag_operations": {
            "add": [],
            "remove": [],
            "set": []
          }
        }
      ]
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing records after a create or update operation.

| Parent field    | Field                             | Type                | Description                                           |
| --------------- | --------------------------------- | ------------------- | ----------------------------------------------------- |
|                 | data [*required*]            | [object]            | List of affected dataset records.                     |
| data            | records [*required*]         | [object]            | List of affected dataset records.                     |
| records         | created_at [*required*]      | date-time           | Timestamp when the record was created.                |
| records         | dataset_id [*required*]      | string              | Identifier of the dataset this record belongs to.     |
| records         | expected_output [*required*] | object <oneOf> | Represents any valid JSON value.                      |
| expected_output | Option 1                          | string              | A scalar string value.                                |
| expected_output | Option 2                          | double              | A scalar numeric value.                               |
| expected_output | Option 3                          | object              | An arbitrary object value with additional properties. |
| expected_output | Option 4                          | [ <oneOf>]     | An array of arbitrary values.                         |
| Option 4        | Option 1                          | string              | A scalar string value.                                |
| Option 4        | Option 2                          | double              | A scalar numeric value.                               |
| Option 4        | Option 3                          | object              | An arbitrary object value with additional properties. |
| Option 4        | Option 4                          | boolean             | A scalar boolean value.                               |
| expected_output | Option 5                          | boolean             | A scalar boolean value.                               |
| records         | id [*required*]              | string              | Unique identifier of the record.                      |
| records         | input [*required*]           | object <oneOf> | Represents any valid JSON value.                      |
| input           | Option 1                          | string              | A scalar string value.                                |
| input           | Option 2                          | double              | A scalar numeric value.                               |
| input           | Option 3                          | object              | An arbitrary object value with additional properties. |
| input           | Option 4                          | [ <oneOf>]     | An array of arbitrary values.                         |
| Option 4        | Option 1                          | string              | A scalar string value.                                |
| Option 4        | Option 2                          | double              | A scalar numeric value.                               |
| Option 4        | Option 3                          | object              | An arbitrary object value with additional properties. |
| Option 4        | Option 4                          | boolean             | A scalar boolean value.                               |
| input           | Option 5                          | boolean             | A scalar boolean value.                               |
| records         | metadata [*required*]        | object              | Arbitrary metadata associated with the record.        |
| records         | updated_at [*required*]      | date-time           | Timestamp when the record was last updated.           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "records": [
        {
          "created_at": "2024-01-15T10:30:00Z",
          "dataset_id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
          "expected_output": {
            "description": "undefined",
            "type": "undefined"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c",
          "input": {
            "description": "undefined",
            "type": "undefined"
          },
          "metadata": {},
          "updated_at": "2024-01-15T10:30:00Z"
        }
      ]
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="413" %}
Payload Too Large
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export project_id="a33671aa-24fd-4dcd-9b33-a8ec7dde7751" export dataset_id="9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d" \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/llm-obs/v1/${project_id}/datasets/${dataset_id}/batch_update" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "create_new_version": true,
      "delete_records": [
        "rec-old-record-1"
      ],
      "insert_records": [
        {
          "expected_output": {
            "answer": "Paris"
          },
          "input": {
            "question": "What is the capital of France?"
          },
          "tags": [
            "topic:geography"
          ]
        }
      ],
      "update_records": [
        {
          "expected_output": {
            "answer": "Paris, France"
          },
          "id": "rec-7c3f5a1b-9e2d-4f8a-b1c6-3d7e9f0a2b4c"
        }
      ]
    },
    "id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
    "type": "datasets"
  }
}
EOF 
                
{% /tab %}
